/* getopt.c -- version of getopt */

#include <stdio.h>

char *optarg;
int optind = 0;
int opterr;

int getopt(argc, argv, optstring)
int argc;
char *argv[];
char *optstring;
{
	static char	*key = NULL;	/* Points to next keyletter */
	/* extern char	*index(); */
	char		c;
	char		*place;

	optarg = NULL;

	if (key == NULL) {		/* First time */
		key = "";
		optind = 1;
	}

	while ((c = *key++) == '\0') {
		if (optind >= argc || *argv[optind] != '-') {
			key--;
			return(EOF);
		}
		key = argv[optind++];
		++key;	/* skip - */
		if (*key == '-') return(EOF);
	}

	/* place = index(optstring, c); */
	place = optstring;
	if (place != NULL) {
		while (*place != '\0' && *place != c) ++place;
		if (*place != c) place = NULL;
	}

	if (place == NULL || c == ':') {
		fprintf(stderr, "%s: illegal option -- %c\n", argv[0], c);
		return('?');
	}

	place++;
	if (*place == ':') {
		if (*key != '\0') {
			optarg = key;
			key = "";
		} else if (optind < argc) {
			optarg = argv[optind];
			optind++;
		} else {
			fprintf(stderr,
				"%s: option requires an argument -- %c\n",
				argv[0], c);
			return('?');
		}
	}

	return(c);
}
