/* tardef.c -- given digit, return info from tar defaults file
 *
 * name = name of device
 * block = blocking factor
 * size = number of blocks
 * tape = true if tape
 *
 * format of def file is
 *   archiven=xxxx	b	s	t
 *	n is a digit, b and s are integer, t is y or n
 *   comment lines start with a #
 */
 
#include <stdio.h>

#ifdef DEBUGDEF
	/* small main program for debugging */
main()
{
	char name[80];
	int i, b, s, t;
	for(i = 0; i < 15; i++) {
		tardef(i, name, &b, &s, &t);
		if (*name)
			printf("%d: %s b %d s %d t %d\n", i, name, b, s, t);
	}
}
#endif

tardef(number, name, block, size, tape)
int number;
char *name;
int *block, *size, *tape;
{
	FILE *deffile;
	char line[80], *s;
	char *archstr;
	int i;

	*name = '\0'; *block = 0; *size = 0; *tape = 1;

	if ((deffile = fopen("/etc/default/tar", "r")) == NULL
#ifdef MSDOS
		&& (deffile = fopen("\\etc\\default\\tar", "r")) == NULL
#endif
		&& (deffile = fopen("tar.def", "r")) == NULL)
		return;

	while (fgets(line, sizeof(line)-1, deffile) != NULL) {
		line[ sizeof(line)-1 ] = '\0';
		s = line;
		if (*s == '#') continue;
		archstr = "archive";
		while (*s && *s == *archstr) {++s; ++archstr;}
		if (*s < '0' || *s > '9') continue;
		for (i = 0; *s >= '0' && *s <= '9'; s++)
			i = i*10 + *s - '0';
		if (i != number) continue;
		if (*s++ != '=') continue;
		while (*s && *s != ' ' && *s != '\t')
			*name++ = *s++;
		*name = '\0';
		while (*s == ' ' || *s == '\t') s++;
		for (*block = 0; *s >= '0' && *s <= '9'; s++)
			*block = *block * 10 + *s - '0';
		while (*s == ' ' || *s == '\t') s++;
		for (*size = 0; *s >= '0' && *s <= '9'; s++)
			*size = *size * 10 + *s - '0';
		while (*s == ' ' || *s == '\t') s++;
		*tape = 1;
		if (*s == 'n' || *s == 'N') *tape = 0;
		break;
	}
	fclose(deffile);
}
